'FFSubmenu=Spiegeln
'FFName=Spiegeln V1.2

' ***********************************************************************
' Script by Lui
' V1.2, 16.10.06
' 
' Dialogbasierter Script mit welchem ein Bild an einer Linie gespiegelt werden kann.
' Spiegellinie und Drehwinkel knnen eingestellt werden

debuging = false

' --------------------------------
' 1.0: - Erstversion
' 1.1: - Click auf Bild zeichnet Spiegellinie in Originalbild
'      - Spiegelung des Originalbildes mglich
'	   - Standard fr Bildvorschau vergrssert
' 1.2: - Vertikal verschieben
'      - 
' ***********************************************************************




' ************** Variablen Definieren
dim shiftX, rotate, x,y
dlgImagesize = 800 				'je kleiner desto schneller, nicht kleiner als 500 einstellen

dim linie,p						' boolean
linie = false
p = false

dim dlg

' ************** Vorbereitungen, Image auf Stack sichern 

call FF_PushImage()								' SaveImage, im Fall von Abbrechen
call FF_PushImage()								' Originalgrsse, wird aber gedreht
call FF_Scale(dlgImagesize,dlgImagesize,true)
call FF_PushImage()								' Verkleinert, wird gedreht

x = FF_GetImageWidth() / 2
y = FF_GetImageHeight() / 2

shiftX = x
shiftY = 0
rotate = 0

call Mirror(shiftX,shiftY,rotate,p)

' ************** Dialog erstellen

call Dialog(false)

' ************** Dialog in Funktion:

do 
	button = FF_ShowDialog(dlg)
	call FF_SetControl (dlg,"Bild",0)
	if debuging then call FF_MessageBox(button,64)
	select case button
		case "<<<"  shiftX = shiftX - 100
		case "<<"   shiftX = shiftX - 10
		case "<"    shiftX = shiftX - 1
		case "0"    shiftX = x
		case ">"    shiftX = shiftX + 1
		case ">>"   shiftX = shiftX + 10
		case ">>>"  shiftX = shiftX + 100
		
		case "vvv"  rotate = rotate + 45
		case "vv"   rotate = rotate + 10
		case "v"    rotate = rotate + 0.5
		case "-"    rotate = 0
		case "^"    rotate = rotate - 0.5
		case "^^"   rotate = rotate - 10
		case "^^^"  rotate = rotate - 45
		
		case "DOWN"  shiftY = shiftY + 100
		case "Down"  shiftY = shiftY + 10
		case "down"  shiftY = shiftY + 1
		case "mitte" shiftY = 0
		case "up"    shiftY = shiftY - 1
		case "Up"    shiftY = shiftY - 10
		case "UP"    shiftY = shiftY - 100
		
		case "Punktspiegelung" if p then p = false else p = true
		
		case "Bild" if linie then linie = false else linie = true
		case "Horizontal" 
			call FF_PopImage
			call FF_HMirror
			call FF_SwapImage
			call FF_HMirror
			call FF_SwapImage
			Call FF_PushImage
		case "Vertikal" 
			call FF_PopImage
			call FF_VMirror
			call FF_SwapImage
			call FF_VMirror
			call FF_SwapImage
			Call FF_PushImage
		case "erweitert" 
			call FF_CloseDialog(dlg)
			call Dialog(true)
	end select
	
	' Wertberschreitungen korrigieren
	if shiftX < 2 then shiftX = 1
	if shiftX > 2 * x then shiftX = 2 * x 
	if rotate < 0 then rotate = rotate + 360
	
	' Dialogbild aktuallisieren
	call FF_PopImage
	call FF_PushImage
	if linie then 
		call MirrorLine(shiftX,rotate)
	else 
		call Mirror(shiftX,shiftY,rotate,p)
	end if
	
loop until button ="OK" or button = "CANCEL" or button = "Abbrechen"

call FF_CloseDialog(dlg)

' ************** Image in Originalgrsse spiegeln

call FF_PopImage
If button = "OK" then
	x = FF_GetImageWidth
	call FF_PopImage
	shiftX = shiftX * FF_GetImageWidth / x
	call Mirror(shiftX,shiftY,rotate,false)
	call FF_SwapImage
	call FF_PopImage
else FF_PopImage
	 FF_PopImage
end if
call FF_Reload


' *********************************************************************
'	Sub Mirror
'	Spiegelt das geladene Bild an der Linie L, wobei l der Abstand vom linken 
' 	Bildrand und Phi der Winkel der vorangestellten Drehung ist
'	punkt = boolean -> Punktspiegelung 
' *********************************************************************


sub Mirror(l,s,phi,punkt)
	if phi > 0 then call FF_Rotate(phi,0,0)
	if l > FF_GetImageWidth then l = FF_GetImageWidth
	call FF_Crop(0,0,l,FF_GetImageHeight)
	call FF_PushImage()
	if punkt then call FF_VMirror
	if s < 0 then call FF_ExtendCanvas(0,FF_GetImageWidth,abs(s),0,0,0,0) else call FF_ExtendCanvas(0,FF_GetImageWidth,0,abs(s),0,0,0)
	call FF_Hmirror
	call FF_SwapImage
	if s > 0 then Call FF_MixImage(0,s,FF_GetImageWidth, FF_GetImageHeight,255) else Call FF_MixImage(0,0,FF_GetImageWidth, FF_GetImageHeight,255)
	call FF_PopImage
end sub

' *********************************************************************



' *********************************************************************
'	Sub MirrorLine
'	Zeichnet eine Spiegellinie im geladenen Bild 
'
' *********************************************************************


sub MirrorLine(l,phi)
	
	if phi > 0 then call FF_Rotate(phi,0,0)
	if l > FF_GetImageWidth then l = FF_GetImageWidth
	call FF_Line(l,0,l,FF_GetImageHeight,0,2)
end sub

' *********************************************************************





' *********************************************************************
'	Sub Dialog
'	
'
' *********************************************************************


sub Dialog(erweitert)

a=0
if erweitert then a=20
call FF_AddDialog  (dlg,dlgImagesize / 2 + 20,a+y+70)
call FF_AddControl (dlg,"Bild","IMAGE",5,5,x,y)
call FF_SetControl (dlg,"Bild",0)

call FF_AddControl (dlg,"Verschiebung","STATIC",5,y+10,40,15)
call FF_AddControl (dlg,"<<<","BUTTON",50,y+10,30,15)
call FF_AddControl (dlg,"<<","BUTTON",80,y+10,30,15)
call FF_AddControl (dlg,"<","BUTTON",110,y+10,30,15)
call FF_AddControl (dlg,"0","BUTTON",145,y+10,20,15)
call FF_AddControl (dlg,">","BUTTON",170,y+10,30,15)
call FF_AddControl (dlg,">>","BUTTON",200,y+10,30,15)
call FF_AddControl (dlg,">>>","BUTTON",230,y+10,30,15)

call FF_AddControl (dlg,"Drehung","STATIC",5,y+30,40,15)
call FF_AddControl (dlg,"vvv","BUTTON",50,y+30,30,15)
call FF_AddControl (dlg,"vv","BUTTON",80,y+30,30,15)
call FF_AddControl (dlg,"v","BUTTON",110,y+30,30,15)
call FF_AddControl (dlg,"-","BUTTON",145,y+30,20,15)
call FF_AddControl (dlg,"^","BUTTON",170,y+30,30,15)
call FF_AddControl (dlg,"^^","BUTTON",200,y+30,30,15)
call FF_AddControl (dlg,"^^^","BUTTON",230,y+30,30,15)

if erweitert then 
	call FF_AddControl (dlg,"Horizontal|","STATIC",5,y+50,40,15)
	call FF_AddControl (dlg,"DOWN","BUTTON",50,y+50,30,15)
	call FF_AddControl (dlg,"Down","BUTTON",80,y+50,30,15)
	call FF_AddControl (dlg,"down","BUTTON",110,y+50,30,15)
	call FF_AddControl (dlg,"mitte","BUTTON",145,y+50,20,15)
	call FF_AddControl (dlg,"up","BUTTON",170,y+50,30,15)
	call FF_AddControl (dlg,"Up","BUTTON",200,y+50,30,15)
	call FF_AddControl (dlg,"UP","BUTTON",230,y+50,30,15)
	call FF_AddControl (dlg,"Punktspiegelung","BUTTON",145,a+y+50,50,15)
else 
	call FF_AddControl (dlg,"erweitert","BUTTON",dlgImagesize / 2-90,y+50,30,15)
end if

call FF_AddControl (dlg,"Original spiegeln:","STATIC",5,a+y+50,40,15)
call FF_AddControl (dlg,"Horizontal","BUTTON",50,a+y+50,30,15)
call FF_AddControl (dlg,"Vertikal","BUTTON",80,a+y+50,30,15)

call FF_AddControl (dlg,"OK","BUTTON",dlgImagesize / 2 -20,a+y+50,30,15)
call FF_AddControl (dlg,"Abbrechen","BUTTON",dlgImagesize / 2-55,a+y+50,30,15)

end sub